package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpNewsBo;
import org.dromara.work.domain.vo.TpNewsVo;
import org.dromara.work.domain.TpNews;
import org.dromara.work.mapper.TpNewsMapper;
import org.dromara.work.service.ITpNewsService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 新闻活动Service业务层处理
 *
 * @author Maosw
 * @date 2025-04-12
 */
@RequiredArgsConstructor
@Service
public class TpNewsServiceImpl implements ITpNewsService {

    private final TpNewsMapper baseMapper;

    /**
     * 查询新闻活动
     *
     * @param id 主键
     * @return 新闻活动
     */
    @Override
    public TpNewsVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询新闻活动列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 新闻活动分页列表
     */
    @Override
    public TableDataInfo<TpNewsVo> queryPageList(TpNewsBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpNews> lqw = buildQueryWrapper(bo);
        Page<TpNewsVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的新闻活动列表
     *
     * @param bo 查询条件
     * @return 新闻活动列表
     */
    @Override
    public List<TpNewsVo> queryList(TpNewsBo bo) {
        LambdaQueryWrapper<TpNews> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpNews> buildQueryWrapper(TpNewsBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpNews> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpNews::getId);
        lqw.eq(bo.getType() != null, TpNews::getType, bo.getType());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), TpNews::getTitle, bo.getTitle());
        lqw.eq(bo.getStatus() != null, TpNews::getStatus, bo.getStatus());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TpNews::getCreateTime ,params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增新闻活动
     *
     * @param bo 新闻活动
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpNewsBo bo) {
        TpNews add = MapstructUtils.convert(bo, TpNews.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改新闻活动
     *
     * @param bo 新闻活动
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpNewsBo bo) {
        TpNews update = MapstructUtils.convert(bo, TpNews.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpNews entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除新闻活动信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
